#ifndef __change_h_
#define __change_h_

#include "mesh.h"

namespace	VMI
{
typedef struct change {
  int e;
  int u, v;           // Edge
  int numDel;         // Number of deleted triangles
  Triangle *deleted;  // List of deleted triangles 
  int numMod;         // Number of modified triangles 
  Triangle *modified; // List of triangles deleted  
} Change;

extern Change *createChange (Mesh *mesh, int e);
extern void writeChange(FILE* file, Change *c);
extern void deleteChange(Change *c);
extern void printChange(Change *c);

extern void modifyTriangle(Triangle *t, int c, int p);
extern int isATriangleToModify(Triangle *t, int c, int p);
extern int getTrianglesToModify(Mesh *mesh, int c, int p, Triangle *modified);
extern int isATriangleToDelete(Triangle *t, int c, int p);
extern int getTrianglesToDelete(Mesh *mesh, int numMod, Triangle *modified, Triangle *deleted, int c, int p);

extern void modifyTriangles(Mesh *mesh, Change *c);
extern void unmodifyTriangles(Mesh *mesh, Change *c);
extern void deleteTriangles(Mesh *mesh, Change *c);
extern void undeleteTriangles(Mesh *mesh, Change *c);

extern void printList(Triangle *list, int n);
extern void deleteItem(Triangle *list, int *n, int item);

extern void doChange(Mesh *mesh, Change *c);
extern void undoChange(Mesh *mesh, Change *c);
extern void computeChanges(Mesh *mesh, Change *c);

}

#endif
