#ifndef __interleave_h_
#define __interleave_h_

#include "GL/glut.h"

#include "color.h"
#include "mesh.h"

namespace	VMI
{
typedef struct _VertexIL {
    GLfloat tx, ty;     // texture coordinates
    GLubyte r, g, b, a; // color
    GLfloat x, y, z;    // position
} VertexIL;

extern VertexIL *intertwined;

typedef struct _Vertex_{
    GLfloat x, y, z;    // position
} Vertex_;

extern void setupInterleave(Mesh *mesh, Color *colors);
extern void setupVertexArray(Mesh *mesh, Color *colorss);
extern void updateVertexArray(Mesh *mesh);
extern void setupVertexBufferObjects(Mesh *mesh, Color *colors);
extern void updateVertexBufferObjects(Mesh *mesh);
extern void printInterleave(int numTriangles);
extern void updateAllColorInterleave(Mesh *mesh, Color *colors);
extern void updateColorInterleave(Mesh *mesh, Color *colors, GLuint begin, GLuint end);
extern void fillColorInterleave(Mesh *mesh, GLuint begin, GLuint end, GLubyte color);

}
#endif
