#ifndef __metrics_h_
#define __metrics_h_

#include "GL/glut.h"

#include "change.h"

namespace	VMI
{
extern GLuint computeBackgroundArea(Mesh *mesh, GLuint *histogram);
extern GLdouble computeMeanProjArea(GLuint **histogram, GLuint numCameras, int t);
extern GLdouble computeMI(Mesh *mesh, GLuint **histogram, GLuint numCameras, GLuint cam);
extern GLdouble computeHE(Mesh *mesh, GLuint *histogram);
extern GLdouble computeKL(Mesh *mesh, GLuint *histogram);
extern GLdouble computeCS(Mesh *mesh, GLuint *histogram);

extern GLdouble computeJS(GLuint **histogram, GLuint numCameras, GLuint j, GLuint k);
extern GLdouble computeEntropy(GLuint **histogram, GLuint numCameras, GLuint k);
extern GLdouble computeMixedEntropy(GLdouble *mixed, GLuint numCameras);
extern GLdouble computeMeanProjAreaNoBG(GLuint **histogram, GLuint numCameras, int t);

extern void getProjectedAreas(GLuint **histogram, GLuint numCameras);
extern void resetProjectedAreas(GLuint **histogram, GLuint numCameras);

extern GLdouble *initIs(GLuint numCameras);
extern void computeCameraIs(GLuint **histogram, GLuint numCameras, GLdouble *mis);
extern void printIs(GLdouble *mis, GLuint numCameras);
}
#endif
