#ifndef __saliency_h_
#define __saliency_h_

#include "metrics.h"
#include "mesh.h"
#include "camera.h"

namespace	VMI
{
extern double maxSal, minSal;
extern int alpha;
extern int lambda;
extern double percentile;

extern void computeSaliency(Mesh *mesh, GLuint **histogram, GLuint numCameras);

extern double computeTriangleSaliency(Mesh *mesh, GLuint **histogram, GLuint numCameras, GLuint k);

extern double computeEdgeSaliency(Mesh *mesh, Change *c, double p);

extern void computeRGB(double min, double max,double value,float *r,float *g,float *b);

extern void viewSaliency(Mesh *mesh, Camera *cameras, int cam);

extern void saveSaliencyMap(Mesh *mesh, char* filename);

extern void loadSaliencyMap(Mesh *mesh, char* filename);

extern double computePercentile(int q, Triangle *triangles, int numTriangles);

extern int compare(const void *arg1, const void *arg2);
extern int isDecimal(double value);

}
#endif
